---
name: Pull Request
about: Pull Request Template
title: ""
labels: ""
assignees: ""
---

Thank you for your Pull Request!

Before you submit, please check that:

- [ ] You mentioned a related Issue if this PR related to it, e.g. `Fixes #228`
      or `Related #1337`.
- [ ] You added a brief description of the PR, e.g.:

  - What does it do?
  - What important points reviewers should know?

- [ ] You labeled the PR appropriately with the labels listed in the sidebar.
- [ ] PR status, release notes, various implications/requirements.
- [ ] You asked any particular reviewers to review. If you aren't sure, start
      with GH suggestions.
- [ ] Your PR adheres to the style guide.
  - In particular, mind the maximal line length of 100 (120 in exceptional
    circumstances).
  - Run `yarn lint`.
  - There is no commented code checked in unless necessary.
- [ ] You updated any documentation that may have changed.

Refer to Substrates’s
[contributing guide](https://github.com/paritytech/substrate/blob/master/docs/CONTRIBUTING.adoc)
or Sidecar API’s
[contributing guide](https://github.com/paritytech/substrate-api-sidecar/tree/master/src/CONTRIBUTING.md)
for details.

After you've read this notice feel free to remove it. Thank you!

✄ -----------------------------------------------------------------------------
